
UNIT uAlleWege;

   ////////////////////////////////////////
   //     AlleWege  *  DemoProgramm      //
   //  --------------------------------  //
   //     Formular-Unit                  //
   ////////////////////////////////////////

INTERFACE

USES
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, Grids, StdCtrls, Buttons, MMSystem, ComCtrls, uDefin;

TYPE
  TfrmAlleWege = CLASS(TForm)
    Schaltleiste: TPanel;
    panMeldung: TPanel;
    HptMenu: TMainMenu;
    HM10: TMenuItem;
    HM20: TMenuItem;
    HM30: TMenuItem;
    HM11: TMenuItem;
    HM12: TMenuItem;
    HM13T: TMenuItem;
    HM14: TMenuItem;
    Kopfleiste: TPanel;
    DamenAuswahl: TListBox;
    btnGreen: TSpeedButton;
    btnRed: TSpeedButton;
    btnHelp: TSpeedButton;
    OptMenu: TMainMenu;
    OM10: TMenuItem;
    panTor: TPanel;
    TitelIcon: TImage;
    Titelfeld1: TMemo;
    Titelfeld2: TLabel;
    labCopyright: TLabel;
    Anzeigefeld: TStringGrid;
    Pausenanzeige: TTrackBar;
    labPause: TLabel;
    panDamenauswahl: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HM11Click(Sender: TObject);
    procedure HM12Click(Sender: TObject);
    procedure HM20Click(Sender: TObject);
    procedure HM30Click(Sender: TObject);
    procedure btnGreenClick(Sender: TObject);
    procedure btnRedClick(Sender: TObject);
    procedure btnHelpClick(Sender: TObject);
    procedure panTorClick(Sender: TObject);
    procedure panTorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure panTorMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PausenanzeigeChange(Sender: TObject);
    procedure DamenAuswahlClick(Sender: TObject);
  PRIVATE
    { Private-Deklarationen }
    procedure TitelEin (Val: Boolean);
    procedure SchalterOnOff (Schalter: tSchalter);
    procedure ProgrammEins;
    procedure ProgrammZwei;
    {}
    procedure SetStein (zl,sp: Integer; Stein: tStein);
    procedure ResetStein (zl,sp: Integer);
    function  IsStein (zl,sp: Integer; Stein: tStein): Boolean;
    procedure SpielplanEinlesen (Name: String);
    procedure SpielfeldInitialisieren;
    {}
    procedure SetzeDame (zl, sp: tZlSp);
    procedure EntferneDame (zl, sp: tZlSp);
    function  IsDameBedroht (zl, sp: tZlSp): Boolean;
    procedure LoesungAusgeben;
    procedure Aufstellen (zl: tZlSp);
  PUBLIC
    { Public-Deklarationen }
  END {der Klassendeklaration};

VAR
  frmAlleWege: TfrmAlleWege;

IMPLEMENTATION

USES
  uAbout;

{$R *.DFM}

{$I IncProcs.inc}

(* ========== Private Deklarationen ==================================== *)

procedure TfrmAlleWege.TitelEin (Val: Boolean);
begin
  case Val of
    true  : begin
              TitelIcon.Visible    := true;
              Titelfeld1.Visible   := true;
              Titelfeld2.Visible   := true;
              labCopyright.Visible := true;
            end;
    false : begin
              TitelIcon.Visible    := false;
              Titelfeld1.Visible   := false;
              Titelfeld2.Visible   := false;
              labCopyright.Visible := false;
            end;
  end{case};
end;

procedure TfrmAlleWege.SchalterOnOff (Schalter: tSchalter);
begin
  case Schalter of
    Aus      : begin
                 btnGreen.Enabled := false;
                 btnRed.Enabled   := false;
               end;
    GruenRot : begin
                 btnGreen.Enabled := true;
                 btnRed.Enabled   := true;
               end;
    Rot      : begin
                 btnGreen.Enabled := false;
                 btnRed.Enabled   := true;
               end;
  end{case};
end;

procedure TfrmAlleWege.ProgrammEins;
// Demonstration Labyrinth
var
  zl, sp: Integer;

  procedure Startplatz (var zl, sp: Integer);
  // Das Startfeld wird gesucht
  var
    i, j: Integer;
  begin
    for i := 0 to ZlAnz-1 do  for j := 0 to SpAnz-1 do
    begin
      if IsStein (i,j,start) then
      begin
        // Leerer Stein muss gesetzt werden, um das Programm zu starten
        SetStein (i,j,leer);
        // Zhlvariable muss unbedingt intern definiert sein,
        // deshalb bertragung der Schleifen-Werte auf die Parameter
        sp := j; zl := i;
      end;
    end{for};
  end{Startplatz};

  procedure Ausgang;
  begin
    Abbruch := false;
    frmAlleWege.panMeldung.Caption :=
      'Ausgang wurde gefunden.    Weiter mit < TASTE > ...';
    WavDateienAbspielen ('go.wav', true);
    frmAlleWege.panTor.Visible := true;
    { Beispiel zum Gebrauch von ProcessMessages:
      Mit der Methode ProcessMessages knnen Sie eine Anwendung unterbrechen,
      so da Windows auf Ereignisse antworten kann. }
    repeat
      Application.ProcessMessages;
    until Abbruch;     // wird durch Taste panTor umgestellt
    { Ende des Beispiels }
    Abbruch := false;  // Abbruch wird wieder zurckgestellt
    panTor.Visible := false;
    panMeldung.Caption := '';
  end;

  procedure Wegsuche (zl, sp: Integer);
  // Der eigentliche "Motor" des Programms
  // Beachte den rekursiven Aufruf mit verschiedenen Parametern!
  begin
    if IsStein (zl,sp,leer) OR IsStein (zl,sp,tor) then
    begin
      if IsStein (zl,sp,tor) then Ausgang
      else
        if IsStein (zl,sp,leer) then
        begin
          SetStein (zl,sp,marke);
          Pause (Pausenzeit);
  (* ================================================ *)
     {}   Wegsuche (zl,sp+1);  {nach rechts}       {}
     {}   Wegsuche (zl+1,sp);  {nach unten }       {}
     {}   Wegsuche (zl,sp-1);  {nach links }       {}
     {}   Wegsuche (zl-1,sp);  {nach oben  }       {}
  (* ================================================ *)
          ResetStein (zl,sp);
          Pause (Pausenzeit);
        end{if IsStein(leer)};
    end{if IsStein};
  end{Wegsuche};

begin
  Startplatz (zl, sp);
  Wegsuche (zl, sp);
  SetStein (zl, sp, schluss);
  Pause (Pausenzeit);
  WavDateienAbspielen ('carosel.wav', true);
  panMeldung.Caption := 'Das Spiel wurde beendet ...';
  SchalterOnOff (Rot);
end {of ProgrammEins};

procedure TfrmAlleWege.ProgrammZwei;
// Demonstration Damen
const
  EinzigerWert = 1;
begin
  Anzeigefeld.Visible := true;
  SpielplanEinlesen ('fldDame');
  SpielfeldInitialisieren;
  Aufstellen (EinzigerWert);
  SchalterOnOff (Rot);
  panDamenAuswahl.Caption := '';
end;

(* ==========  Private Deklarationen (Spielsteine)  ==================== *)

procedure TfrmAlleWege.SetStein (zl,sp: Integer; Stein: tStein);
// Ein auszuwhlender Stein wird gesetzt
var
  z: Char;
begin
  z := #0;
  if (zl >= 0)AND(zl < ZlAnz)AND(sp >= 0)AND(sp < SpAnz) then
  begin
    case Stein of
      leer    : z := stLeer;
      start   : z := stStart;
      mauer   : z := stMauer;
      tor     : z := stTor;
      marke   : z := stMarke;
      schluss : z := stSchluss;
    end{case};
    frmAlleWege.Anzeigefeld.Cells [sp, zl] := z;
  end{if};
end{SetStein};

procedure TfrmAlleWege.ResetStein (zl,sp: Integer);
// Ein Stein wird gelscht (wird mit Leerzeichen berschrieben)
begin
  SetStein (zl,sp,leer);
end{ResetStein};

function  TfrmAlleWege.IsStein (zl,sp: Integer; Stein: tStein): Boolean;
// Feststellung, ob der gesuchte Stein der gewnschte ist
var
  z: String;
begin
  case Stein of
    leer    : z := stLeer;
    start   : z := stStart;
    mauer   : z := stMauer;
    tor     : z := stTor;
    marke   : z := stMarke;
    schluss : z := stSchluss;
  end{case};
  if frmAlleWege.Anzeigefeld.Cells [sp,zl] = z then
    Result := true else Result := false;
end{IsStein};

procedure TfrmAlleWege.SpielplanEinlesen (Name: String);
// Fr mehrere Grundrisse gedacht
var
  i,j: Integer;
begin
  { Das auszuwhlende Array einlesen }
  for i := 0 to ZlAnz-1 do for j := 0 to SpAnz-1 do
         if Name = 'Laby' then Plan[i,j] := fldLaby[i,j]
    else if Name = 'Dame' then Plan[i,j] := fldDame[i,j];
end{SpielplanEinlesen};

procedure TfrmAlleWege.SpielfeldInitialisieren;
// Den ausgewhlten Grundriss einlesen
var
  i,j: Integer;
begin
  for i := 0 to ZlAnz-1 do for j := 0 to SpAnz-1 do
    Anzeigefeld.Cells[j,i] := Plan[i,j];
    { WICHTIG! Die Umstellung von j,i nach i,j beachten ! }
end{SpielplanInitialisieren};

(* ========== Private Deklarationen (Damen) ============================ *)

procedure TfrmAlleWege.SetzeDame (zl, sp: tZlSp);
begin
  Dame[zl]     := sp;
  Spalte[sp]   := ja;
  Diag1[zl+sp] := ja;
  Diag2[zl-sp] := ja;
end;

procedure TfrmAlleWege.EntferneDame (zl, sp: tZlSp);
begin
  Spalte[sp]   := nein;
  Diag1[zl+sp] := nein;
  Diag2[zl-sp] := nein;
end;

function TfrmAlleWege.IsDameBedroht (zl, sp: tZlSp): Boolean;
begin
  Result :=
    (Spalte[sp] = ja) OR (Diag1[zl+sp] = ja) OR (Diag2[zl-sp] = ja);
end;

procedure TfrmAlleWege.LoesungAusgeben;
var
  zl, sp: Integer;
  st: String;
begin
  lfdNr := succ(lfdNr);
  for zl := 1 TO varDamen do for sp := 1 to varDamen do
  begin
    if Dame[zl] = sp then SetStein (zl+Startwert,sp+Startwert+5,marke)
    else SetStein (zl+Startwert,sp+Startwert+5,leer);
  end;
  str (lfdNr:2, st);
  panMeldung.Caption :=
    'Lsung #'+st+'    *  Weiter mit < TASTE > ...';
  Abbruch := false;
  panTor.Visible := true;
  { Siehe auch procedure Ausgang in ProgrammEins als Beispiel }
  repeat
    Application.ProcessMessages;
  until Abbruch;
  { }
  Abbruch := false;
  panTor.Visible := false;
  panMeldung.Caption := '';
end;

procedure TfrmAlleWege.Aufstellen (zl: tZlSp);
var
  sp: tZlSp;
begin
  for sp := 1 to varDamen do
  begin
    if not IsDameBedroht (zl,sp) then
    begin
      SetzeDame (zl, sp);
      if zl < varDamen then
        Aufstellen (zl+1)
      else
        LoesungAusgeben;
      EntferneDame (zl,sp);
    end;
  end;
end;

(* ========== Deklarationen der Applikation ============================ *)

procedure TfrmAlleWege.FormCreate(Sender: TObject);
begin
  // Men Zuweisung Hauptmen
  Menu := HptMenu;
  Progs := ProgNix;
  Abbruch := false;
end;

procedure TfrmAlleWege.FormShow(Sender: TObject);
begin
  SchalterOnOff (Aus);
  Pausenzeit := 100;
  labPause.Caption := '1/100';
  Pausenanzeige.Position := 1;
end;

procedure TfrmAlleWege.FormActivate(Sender: TObject);
begin
  frmAlleWege.HM20Click(Sender);
end;

procedure TfrmAlleWege.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
const
  tx = '  Mit <Ja> knnen Sie das Programm beenden ...  ';
begin
  if Application.MessageBox (tx, ' Programm beenden', MB_YesNo) = IDYes
  then CanClose := true else CanClose := false;
end;

procedure TfrmAlleWege.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmAlleWege.HM11Click(Sender: TObject);
begin
  Progs := ProgEins;
  Menu := OptMenu;
  SchalterOnOff (GruenRot);
  Anzeigefeld.Visible := true;
  Anzeigefeld.Options := [];
  Pausenanzeige.Visible := true;
  labPause.Visible := true;
  DamenAuswahl.Visible := false;
  panDamenAuswahl.Caption := '';
  SpielplanEinlesen ('Laby');
  SpielfeldInitialisieren;
  Kopfleiste.Caption := 'Alle Ausgnge suchen';
  Anzeigefeld.SetFocus;
end;

procedure TfrmAlleWege.HM12Click(Sender: TObject);
begin
  Progs := ProgZwei;
  Menu := OptMenu;
  SchalterOnOff (Rot);
  Anzeigefeld.Visible := true;
  Anzeigefeld.Options := [goVertLine,goHorzLine];
  Pausenanzeige.Visible := false;
  labPause.Visible := false;
  DamenAuswahl.Visible := true;
  DamenAuswahl.ItemIndex := 0;
  panDamenAuswahl.Caption := 'Start = Auswahl + Klicken ==>';
  SpielplanEinlesen ('Dame');
  SpielfeldInitialisieren;
  Kopfleiste.Caption := 'Probleme mit den (acht) Damen';
  Anzeigefeld.SetFocus;
end;

procedure TfrmAlleWege.HM20Click(Sender: TObject);
begin
  TitelEin (false);
  SchalterOnOff (Aus);
  frmAbout.ShowModal;
  TitelEin (true);
end;

procedure TfrmAlleWege.HM30Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmAlleWege.btnGreenClick(Sender: TObject);
begin
  SchalterOnOff (Aus);
  if Progs = ProgEins then ProgrammEins
  else if Progs = ProgZwei then ProgrammZwei;
end;

procedure TfrmAlleWege.btnRedClick(Sender: TObject);
begin
  SchalterOnOff (Aus);
  Anzeigefeld.Visible := false;
  panMeldung.Caption := '';
  panDamenauswahl.Caption := '';
  DamenAuswahl.Visible := false;
  Kopfleiste.Caption := '';
  Pausenanzeige.Visible := false;
  labPause.Visible := false;
  Progs := ProgNix;
  Menu := HptMenu;
end;

procedure TfrmAlleWege.btnHelpClick(Sender: TObject);
begin
  Application.HelpFile := 'Labyrint.HLP';
  case Progs of
    ProgEins : Application.HelpJump ('IDH_1000');
    ProgZwei : Application.HelpJump ('IDH_2000');
  else
    Application.HelpJump ('IDH_9000');
  end{case};
end;

procedure TfrmAlleWege.panTorClick(Sender: TObject);
begin
  Abbruch := true;
  panTor.Hide;
  panMeldung.Caption := '';
end;

procedure TfrmAlleWege.panTorMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
// Panel als Schalter * Realisiert die Schalterfunktion (1)
begin
  panTor.BevelOuter := bvLowered;
  panTor.Color := clRed;
end;

procedure TfrmAlleWege.panTorMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  // Panel als Schalter * Realisiert die Schalterfunktion (2)
begin
  panTor.BevelOuter := bvRaised;
  panTor.Color := clGreen;
end;

procedure TfrmAlleWege.PausenanzeigeChange(Sender: TObject);
begin
  case Pausenanzeige.Position of
    0     : Pausenzeit := 0;
    1..18 : Pausenzeit := Pausenanzeige.Position * 100;
    19    : Pausenzeit := 2500;
    20    : Pausenzeit := 4000;
  end{case};
  labPause.Caption :=
    IntToStr(Pausenanzeige.Position)+'/'+IntToStr(Pausenzeit);
end;

procedure TfrmAlleWege.DamenAuswahlClick(Sender: TObject);
begin
  SchalterOnOff (GruenRot);
  lfdNr := 0;   // lfdNr zuerst zurckstellen
  case DamenAuswahl.ItemIndex of
    0 : begin
          varDamen := 8 ;
          Startwert := 2;
          panDamenauswahl.Caption := '92 Lsungen';
        end;
    1 : begin
          varDamen := 7 ;
          Startwert := 2;
          panDamenauswahl.Caption := '40 Lsungen';
        end;
    2 : begin
          varDamen := 6 ;
          Startwert := 3;
          panDamenauswahl.Caption := '4 Lsungen';
        end;
    3 : begin
          varDamen := 5 ;
          Startwert := 3;
          panDamenauswahl.Caption := '10 Lsungen';
        end;
    4 : begin
          varDamen := 4 ;
          Startwert := 4;
          panDamenauswahl.Caption := '2 Lsungen';
        end;
  end{case};
  DamenAuswahl.Hide;
end;

INITIALIZATION

END {der Unit uAlleWege}.


