
unit uBckTrack;
{ Formularunit Beispielprogramm Backtracking }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TfrmBacktr = class(TForm)
    Bildflaeche: TImage;
    btnWeiter: TButton;
    btnStart: TButton;
    btnBeenden: TBitBtn;
    Anzeigefeld: TLabel;
    Copyright: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnStartClick(Sender: TObject);
    procedure btnWeiterClick(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure SetItem (sp,zl,item: Integer);
    procedure ResetItem (sp,zl: Integer);
    procedure WriteItem (sp,zl,item: Integer);
    function  IsItem (sp,zl,item: Integer): Boolean;
    procedure BewegeItem (sp,zl: Integer);
    procedure Ausgang;
  public
    { Public-Deklarationen }
  end;

var
  frmBacktr: TfrmBacktr;

const
  weg   = 0;
  wand  = 1;
  tor   = 2;
  spur  = 3;
  start = 4;
  ziel  = 5;

  fk    = 25;  // Faktor zur Korrektur der Ausgabepunkte im Bildfeld
  MaxSp = 20;
  MaxZl = 20;

  Aktiv : boolean = true;
  Pausenzeit : Integer = 200;

  Laby : Array[0..MaxSp-1, 0..MaxZl-1] of Integer =
  ((1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1),
   (1,0,0,1,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,1),
   (1,0,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1),     
   (1,0,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1),
   (1,0,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1),
   (1,0,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1),
   (1,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,0,2),
   (1,0,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1),
   (1,0,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1),
   (1,0,1,1,0,1,1,1,1,0,0,0,0,0,1,1,1,1,0,1),
   (1,0,1,1,0,1,1,1,1,1,1,1,1,0,1,1,1,1,0,1),
   (1,0,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1),
   (1,0,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1),
   (1,0,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1),
   (1,0,1,1,0,0,1,0,0,0,1,1,1,0,1,1,1,1,0,1),
   (1,1,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1),
   (1,0,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1),
   (1,0,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1),
   (1,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,1,0,1),
   (1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1));

var
  Itemfeld : Array[0..5] of TBitmap;
  ItemRect : TRect;

implementation

{$R *.DFM}

procedure Delay (num: LongInt); {n~Millisekunden}
var
  tc: LongInt;
begin
  tc := GetTickCount;
  repeat
    Application.ProcessMessages;
  until ((GetTickCount - tc) >= num);
end {delay};

{ ========== Items-Hilfsprozeduren ===================================== }

procedure TfrmBacktr.SetItem (sp,zl,item: Integer);
{ Der Item mit Nummer item wird an der Stelle sp,zl gezeigt }
var
  ScreenRect: TRect;
begin
  ScreenRect := Rect(sp,zl, sp+fk,zl+fk);
  frmBacktr.Bildflaeche.Canvas.CopyMode := cmSrcCopy;
  frmBacktr.Bildflaeche.Canvas.CopyRect
    (ScreenRect, Itemfeld[item].Canvas, ItemRect);
end {ShowSprite};

procedure TfrmBacktr.ResetItem (sp,zl: Integer);
{ Lscht den gewhlten Item }
begin
  frmBacktr.SetItem (sp*fk,zl*fk,weg);
end {ResetItem};

procedure TfrmBacktr.WriteItem (sp,zl,item: Integer);
{ Gibt einen Item auf dem Bildschirm aus }
{ und schreibt den Item in das Array ein }
begin
  Laby [zl,sp] := item; // Umkehr sp,zl im Array Laby beachten !!
  sp := sp*fk; zl := zl*fk;
  SetItem (sp,zl,item);
end {WriteItem};

function TfrmBacktr.IsItem (sp,zl,item: Integer): Boolean;
{ berprft, ob der ausgewhlze Item vorhanden ist }
begin
  // Umkehr sp,zl im Array Laby beachten !
  if Laby[zl,sp] = item then Result := true else Result := false;
end {IsItem};

{ ----------------------------------------------------------------------- }

procedure TfrmBacktr.BewegeItem (sp,zl: Integer);
{ Der eigentliche "Motor" des Programms }
{ Beachte die rekursiven Aufrufe }
begin
  if IsItem (sp,zl,weg) OR IsItem (sp,zl,tor) then
  begin
    if IsItem (sp,zl,tor) then Ausgang
    else
      if IsItem (sp,zl,weg) then
      begin
        WriteItem (sp,zl,spur);
        delay (Pausenzeit);
{ ----- Die rekursiven Aufrufe der Prozedur BewegeItem ----- }
             BewegeItem (sp+1, zl);  {nach rechts}
             BewegeItem (sp, zl+1);  {nach unten }
             BewegeItem (sp-1, zl);  {nach links }
             BewegeItem (sp, zl-1);  {nach oben  }
{ ----- Ende der Aufrufe ----------------------------------- }
        ResetItem (sp,zl);
        delay (Pausenzeit);
      end{if IsStein 2};
  end {if IsStein 1};
end {bewege};

{ ----------------------------------------------------------------------- }

procedure TfrmBacktr.Ausgang;
begin
  btnWeiter.Visible := true;
  Anzeigefeld.Caption := 'Ausgang gefunden';
  repeat
    Application.ProcessMessages;
  until Aktiv = false;
  Anzeigefeld.Caption := #0;
  btnWeiter.Visible := false;
end {Ausgang};

{ ======================================================================= }


procedure TfrmBacktr.FormCreate(Sender: TObject);
var
  i, sp, zl: integer;
begin
  for i := 0 to 5 do Itemfeld[i] := TBitmap.Create;
  Itemfeld[0].LoadFromFile('00.bmp');
  Itemfeld[1].LoadFromFile('01.bmp');
  Itemfeld[2].LoadFromFile('02.bmp');
  Itemfeld[3].LoadFromFile('03.bmp');
  Itemfeld[4].LoadFromFile('04.bmp');
  Itemfeld[5].LoadFromFile('05.bmp');
  {}
  ItemRect := Rect (0, 0, fk, fk);
  { Items auf Bildflaeche setzen }
  for sp := 0 to MaxSp-1 do for zl := 0 to MaxZl-1 do
    SetItem (sp*fk, zl*fk, Laby[zl, sp]);  // Reihenfolge Laby beachten !!
  {}  
  Anzeigefeld.Caption := #0;
  btnStart.Enabled := true;
  btnWeiter.Visible := false;
  btnBeenden.Enabled := true; 
end;

procedure TfrmBacktr.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
const
  tx = '  Wollen Sie das Programm wirklich beenden ?  ';
begin
  if Application.MessageBox
    (tx, ' Programm beenden', MB_YesNo) = IDYes then CanClose := true
  else CanClose := false;
end;

procedure TfrmBacktr.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;  // Schliessen und Speicher freigeben
end;

procedure TfrmBacktr.btnStartClick(Sender: TObject);
begin
  btnBeenden.Enabled := false;
  btnWeiter.Hide;
  btnStart.Enabled := false;
  Aktiv := true;
  BewegeItem (1,1);
  Anzeigefeld.Caption := 'Durchlauf beendet';
  btnBeenden.Enabled := true;
end;

procedure TfrmBacktr.btnWeiterClick(Sender: TObject);
begin
  Aktiv := false;
end;

end.
