
UNIT uDame;

{ ======================================================================== }
{   Formularunit uDame zu Tutorial "Wege aus dem Labyrinth"                }
{ ======================================================================== }

INTERFACE

USES
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, Buttons, MMSystem, uDefin;

TYPE
  TfrmDame = CLASS(TForm)
    Ausgabefeld: TStringGrid;
    Schaltleiste: TPanel;
    panMeldung: TPanel;
    btnSpiel1: TSpeedButton;
    btnSpiel2: TSpeedButton;
    btnGreen: TSpeedButton;
    btnRed: TSpeedButton;
    btnBeenden: TSpeedButton;
    panTor: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSpiel1Click(Sender: TObject);
    procedure btnSpiel2Click(Sender: TObject);
    procedure btnGreenClick(Sender: TObject);
    procedure btnRedClick(Sender: TObject);
    procedure btnBeendenClick(Sender: TObject);
    procedure panTorClick(Sender: TObject);
    procedure panTorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure panTorMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
    procedure SetzeDame (zl, sp: tZlSp);
    procedure EntferneDame (zl, sp: tZlSp);
    function  IsDameBedroht (zl, sp: tZlSp): Boolean;
    procedure LoesungAusgeben;
    procedure Aufstellen (zl: tZlSp);
    procedure SpielfeldInitialisieren;
    procedure SetStein (zl,sp: Integer; Stein: tStein);
  public
    { Public-Deklarationen }
  END {der Typdefinition};

VAR
  frmDame: TfrmDame;

IMPLEMENTATION

{$R *.DFM}

(* Die Includedatei wird nur zur Demonstration eingefhrt.
   Im Implementation-Teil einzufgen, da in IncProcs.inc Prozeduren
   definiert sind. Anweisungen im Interface-Teil sind nicht erlaubt. *)

{$I IncProcs.inc}

(* ========== Private Deklarationen (Damen) ====================== *)

procedure TfrmDame.SetzeDame (zl, sp: tZlSp);
begin
  Dame[zl]     := sp;
  Spalte[sp]   := ja;
  Diag1[zl+sp] := ja;
  Diag2[zl-sp] := ja;    
end;

procedure TfrmDame.EntferneDame (zl, sp: tZlSp);
begin
  Spalte[sp]   := nein;
  Diag1[zl+sp] := nein;
  Diag2[zl-sp] := nein;
end;

function TfrmDame.IsDameBedroht (zl, sp: tZlSp): Boolean;
begin
  Result :=
    (Spalte[sp] = ja) OR (Diag1[zl+sp] = ja) OR (Diag2[zl-sp] = ja);
end;

procedure TfrmDame.LoesungAusgeben;
var
  zl, sp: Integer;
  st: String;
begin
  lfdNr := succ(lfdNr);
  for zl := 1 TO varDamen do for sp := 1 to varDamen do
  begin
    if Dame[zl] = sp then SetStein (zl+Startpos,sp+Startpos,marke)
    else SetStein (zl+Startpos,sp+Startpos,leer);
  end;
  str (lfdNr:3, st);
  frmDame.panMeldung.Caption :=
    'Lsung Nr. '+st+'     < TASTE > ...';
  Abbruch := false;
  frmDame.panTor.Visible := true;
  repeat
    Application.ProcessMessages;
  until Abbruch;
  Abbruch := false;
  frmDame.panTor.Visible := false;
  frmDame.panMeldung.Caption := '';
end;

procedure TfrmDame.Aufstellen (zl: tZlSp);
var
  sp: tZlSp;
begin
  for sp := 1 to varDamen do
  begin
    if not IsDameBedroht (zl,sp) then
    begin
      SetzeDame (zl, sp);
      if zl < varDamen then
        Aufstellen (zl+1)
      else
        LoesungAusgeben;
      EntferneDame (zl,sp);
    end;
  end;
end;

procedure TfrmDame.SpielfeldInitialisieren;
// Das Ausgabefeld auf Bildschirm ausgeben
var
  i, j: Integer;
begin
  for i := 0 to MaxZeile - 1 do  for j := 0 to MaxSpalte - 1 do
    Ausgabefeld.Cells [i,j] := fldDame [j,i];
    { Die Umstellung von i,j nach j,i beachten ! }
end{SpielfeldInitialisieren};

procedure TfrmDame.SetStein (zl,sp: Integer; Stein: tStein);
// Ein auszuwhlender Stein wird gesetzt
var
  z: Char;
begin
  z := #0;
  if (zl >= 0)AND(zl < MaxZeile)AND(sp >= 0)AND(sp < MaxSpalte) then
  begin
    case Stein of
      leer    : z := stLeer;
      mauer   : z := stMauer;
      marke   : z := stMarke;
    end{case};
    frmDame.Ausgabefeld.Cells [sp, zl] := z;
  end{if};
end{SetStein};

(* ========== Deklarationen der Applikation ============================ *)

procedure TfrmDame.FormCreate(Sender: TObject);
begin
  Abbruch  := false;
  varDamen := 0;
  Startpos := 0;
end;

procedure TfrmDame.FormShow(Sender: TObject);
begin
  btnSpiel1.Enabled := true;
  btnSpiel2.Enabled := true;
  btnGreen.Enabled := false;
  btnRed.Enabled := false;
  btnBeenden.Enabled := true;
end;

procedure TfrmDame.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
const
  tx = '  Wollen Sie das Programm wirklich beenden ?  ';
begin
  if Application.MessageBox
    (tx, ' Programm beenden', MB_YesNo) = IDYes then CanClose := true
  else CanClose := false;
end;

procedure TfrmDame.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmDame.btnSpiel1Click(Sender: TObject);
begin
  SpielfeldInitialisieren;
  panMeldung.Caption := #0;
  btnGreen.Enabled := true;
  btnRed.Enabled := true;
  btnBeenden.Enabled := false;
  varDamen := 4;
  Startpos := 3;
  panMeldung.Caption := '4 Damen = 2 Lsungen';
end;

procedure TfrmDame.btnSpiel2Click(Sender: TObject);
begin
  btnSpiel1Click (Sender);
  varDamen := 6;
  Startpos := 2;
  panMeldung.Caption := '6 Damen = 4 Lsungen';
end;

procedure TfrmDame.btnGreenClick(Sender: TObject);
const
  EinzigerWert = 1;
begin
  lfdNr := 0;
  btnSpiel1.Enabled := false;
  btnSpiel2.Enabled := false;
  btnGreen.Enabled := false;
  btnRed.Enabled := false;
  btnBeenden.Enabled := false;    
  Aufstellen (EinzigerWert);
  btnRed.Enabled := true;
  panMeldung.Caption := 'Anzeige ist beendet';
end;

procedure TfrmDame.btnRedClick(Sender: TObject);
begin
  SpielfeldInitialisieren;
  panMeldung.Caption := 'Neue Auswahl treffen oder beenden ...';
  btnSpiel1.Enabled := true;
  btnSpiel2.Enabled := true;
  btnGreen.Enabled := false;
  btnRed.Enabled := false;
  btnBeenden.Enabled := true;
end;

procedure TfrmDame.btnBeendenClick(Sender: TObject);
// Beendet das Programm
begin
  Close;
end;

procedure TfrmDame.panTorClick(Sender: TObject);
// Schaltet den Programmverlauf weiter
begin
  Abbruch := true;
  panTor.Visible := false;
  panMeldung.Caption := #0;
end;

procedure TfrmDame.panTorMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  // Panel als Schalter * Realisiert die Schalterfunktion (1)
begin
  panTor.BevelOuter := bvLowered;
  panTor.Color := clRed;
end;

procedure TfrmDame.panTorMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  // Panel als Schalter * Realisiert die Schalterfunktion (2)
begin
  panTor.BevelOuter := bvRaised;
  panTor.Color := clGreen;
end;

END {der Unit uDame}.
