
UNIT uWege;

{ ======================================================================== }
{   Formularunit uWege zu Tutorial "Wege aus dem Labyrinth"                }
{ ======================================================================== }

INTERFACE

USES
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, Buttons, MMSystem;

(* Die Includedatei wird nur zur Demonstration eingefhrt.
   Wegen der Typdefinitionen in IncDefin.inc hier ganz vorn eingefgt. *)

{$I IncDefin.inc}

(* -------------------------------------------------------------------
   Includedateien verteilen den Quellcode einer Unit auf mehrere
   Dateien. Units dagegen dienen zur modularen Gestaltung eines
   Delphi-Programmprojektes.
   Die Parameter-Direktive $I weist den Compiler an, die angegebene
   Datei in die Compilierung aufzunehmen. Diese Datei wird >> direkt
   nach der Direktive {$I Dateiname} << in den Text eingefgt.
   Siehe auch Includedatei im Implementations-Abschnitt.
   ------------------------------------------------------------------- *)
  

TYPE
  TfrmWege = CLASS(TForm)
    Ausgabefeld: TStringGrid;
    Schaltleiste: TPanel;
    panMeldung: TPanel;
    btnSpiel1: TSpeedButton;
    btnSpiel2: TSpeedButton;
    btnGreen: TSpeedButton;
    btnRed: TSpeedButton;
    btnBeenden: TSpeedButton;
    btnPause: TSpeedButton;
    panTor: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSpiel1Click(Sender: TObject);
    procedure btnSpiel2Click(Sender: TObject);
    procedure btnGreenClick(Sender: TObject);
    procedure btnRedClick(Sender: TObject);
    procedure btnBeendenClick(Sender: TObject);
    procedure AusgabefeldSelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure btnPauseClick(Sender: TObject);
    procedure panTorClick(Sender: TObject);
    procedure panTorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure panTorMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
    procedure Startplatz (var zl, sp: Integer);
    procedure SetStein (zl,sp: Integer; Stein: tStein);
    procedure ResetStein (zl,sp: Integer);
    function  IsStein (zl,sp: Integer; Stein: tStein): Boolean;
    procedure SpielfeldInitialisieren;
    procedure SpielplanEinlesen (Name: String);
    procedure Wegsuche (zl, sp: Integer);
    procedure Ausgang;
    procedure Ende;
  public
    { Public-Deklarationen }
  END {der Typdefinition};

VAR
  frmWege: TfrmWege;

IMPLEMENTATION

{$R *.DFM}

(* Die Includedatei wird nur zur Demonstration eingefhrt.
   Im Implementation-Teil einzufgen, da in IncProcs.inc Prozeduren
   definiert sind. Anweisungen im Interface-Teil sind nicht erlaubt. *)

{$I IncProcs.inc}

(* ========== Private Deklarationen (Spielsteine) ====================== *)

procedure TfrmWege.Startplatz (var zl, sp: Integer);
// Das Startfeld wird gesucht
var
  i, j: Integer;
begin
  for i := 0 to MaxZeile-1 do  for j := 0 to MaxSpalte-1 do
  begin
    if IsStein (i,j,start) then
    begin
      // Leerer Stein muss gesetzt werden, um das Programm zu starten
      SetStein (i,j,leer);
      // Zhlvariable muss unbedingt intern definiert sein,
      // deshalb bertragung der Schleifen-Werte auf die Parameter
      zl := i; sp := j;
    end;
  end{for};
end{Startplatz};

procedure TfrmWege.SetStein (zl,sp: Integer; Stein: tStein);
// Ein auszuwhlender Stein wird gesetzt
var
  z: Char;
begin
  z := #0;
  if (zl >= 0)AND(zl < MaxZeile)AND(sp >= 0)AND(sp < MaxSpalte) then
  begin
    case Stein of
      leer    : z := stLeer;
      start   : z := stStart;
      mauer   : z := stMauer;
      tor     : z := stTor;
      marke   : z := stMarke;
    end{case};
    frmWege.Ausgabefeld.Cells [sp, zl] := z;
  end{if};
end{SetStein};

procedure TfrmWege.ResetStein (zl,sp: Integer);
// Ein Stein wird gelscht (wird mit Leerzeichen berschrieben)
begin
  SetStein (zl,sp,leer);
end{ResetStein};

function  TfrmWege.IsStein (zl,sp: Integer; Stein: tStein): Boolean;
// Feststellung, ob der gesuchte Stein der gewnschte ist
var
  z: String;
begin
  case Stein of
    leer    : z := stLeer;
    start   : z := stStart;
    mauer   : z := stMauer;
    tor     : z := stTor;
    marke   : z := stMarke;
  end{case};
  if frmWege.Ausgabefeld.Cells [sp,zl] = z then
    Result := true else Result := false;
end{IsStein};

procedure TfrmWege.SpielfeldInitialisieren;
// Den ausgewhlten Labyrinth-Grundriss auf Bildschirm ausgeben
var
  i, j: Integer;
begin
  for i := 0 to MaxZeile - 1 do  for j := 0 to MaxSpalte - 1 do
    Ausgabefeld.Cells [i,j] := Plan [j,i];
    { Die Umstellung von i,j nach j,i beachten ! }
end{SpielfeldInitialisieren};

procedure TfrmWege.SpielplanEinlesen (Name: String);
var
  i,j: Integer;
begin
  { Das auszuwhlende Array einlesen }
  for i := 0 to MaxZeile-1 do for j := 0 to MaxSpalte-1 do
  begin
         if Name = 'Laby0' then Plan[i,j] := Laby0[i,j]
    else if Name = 'Laby1' then Plan[i,j] := Laby1[i,j]
    else if Name = 'Laby2' then Plan[i,j] := Laby2[i,j];
  end{for};
end{SpielplanEinlesen};

procedure TfrmWege.Wegsuche (zl, sp: Integer);
// Der eigentliche "Motor" des Programms
// Beachte den rekursiven Aufruf!
begin
  if IsStein (zl,sp,leer) OR IsStein (zl,sp,tor) then
  begin
    if IsStein (zl,sp,tor) then Ausgang
    else
      if IsStein (zl,sp,leer) then
      begin
        SetStein (zl,sp,marke);
        Pause (Pausenzeit);
(* ================================================ *)
   {}   Wegsuche (zl,sp+1);  {nach rechts}       {}
   {}   Wegsuche (zl+1,sp);  {nach unten }       {}
   {}   Wegsuche (zl,sp-1);  {nach links }       {}
   {}   Wegsuche (zl-1,sp);  {nach oben  }       {}
(* ================================================ *)
        ResetStein (zl,sp);
        Pause (Pausenzeit);
      end{if IsStein(leer)};
  end{if IsStein};  
end{Wegsuche};

procedure TfrmWege.Ausgang;
// Zeigt Torausgang im Programm an
begin
  panMeldung.Caption := 'Ausgang gefunden !! Weiter mit <TASTE> ...';
  WAVDateienAbspielen ('go.wav', false);
  panTor.Visible := true;
  repeat
      Application.ProcessMessages;
  until Abbruch;
  abbruch := false;
end{Ausgang};

procedure TfrmWege.Ende;
// Abschluss des Programms
begin
  panMeldung.Caption := 'Demoprogramm Labyrinth beendet !!';
  WAVDateienAbspielen ('carosel.wav', false);
  Pause (4000);
  panMeldung.Caption := #0;
  btnSpiel1.Enabled := false;
  btnSpiel2.Enabled := false;
  btnGreen.Enabled := false;
  btnRed.Enabled := true;
  btnPause.Enabled := false;
  btnBeenden.Enabled := false;;
end{Ende};

(* ========== Deklarationen der Applikation ============================ *)

procedure TfrmWege.FormCreate(Sender: TObject);
begin
  // Linien zwischen den Feldern entfernen
  Ausgabefeld.Options := [];
  Pausenzeit := 100;  // kurze Pausenzeit
  btnPause.Caption := 'K';
  Abbruch := false;
end;

procedure TfrmWege.FormShow(Sender: TObject);
begin
  btnSpiel1.Enabled := true;
  btnSpiel2.Enabled := true;
  btnGreen.Enabled := false;
  btnRed.Enabled := false;
  btnPause.Enabled := false;
  btnBeenden.Enabled := true;
end;

procedure TfrmWege.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
const
  tx = '  Wollen Sie das Programm wirklich beenden ?  ';
begin
  if Application.MessageBox
    (tx, ' Programm beenden', MB_YesNo) = IDYes then CanClose := true
  else CanClose := false;
end;

procedure TfrmWege.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmWege.btnSpiel1Click(Sender: TObject);
begin
  SpielplanEinlesen ('Laby1');
  SpielfeldInitialisieren;
  panMeldung.Caption := #0;
  btnGreen.Enabled := true;
  btnRed.Enabled := true;
  btnPause.Enabled := true;
end;

procedure TfrmWege.btnSpiel2Click(Sender: TObject);
begin
  SpielplanEinlesen ('Laby2');
  SpielfeldInitialisieren;
  panMeldung.Caption := #0;
  btnGreen.Enabled := true;
  btnRed.Enabled := true;
  btnPause.Enabled := true;
end;

procedure TfrmWege.btnGreenClick(Sender: TObject);
var
  z, s: Integer;
begin
  btnSpiel1.Enabled := false;
  btnSpiel2.Enabled := false;
  btnGreen.Enabled := false;
  btnRed.Enabled := false;
  btnPause.Enabled := true;
  btnBeenden.Enabled := false;
  Startplatz (z,s);
  Wegsuche (z,s);
  Ende;
end;

procedure TfrmWege.btnRedClick(Sender: TObject);
begin
  SpielplanEinlesen ('Laby0');
  SpielfeldInitialisieren;
  panMeldung.Caption := 'Labyrinth auswhlen oder beenden ...';
  btnSpiel1.Enabled := true;
  btnSpiel2.Enabled := true;
  btnGreen.Enabled := false;
  btnRed.Enabled := false;
  btnPause.Enabled := false;
  btnBeenden.Enabled := true;
end;

procedure TfrmWege.btnBeendenClick(Sender: TObject);
// Beendet das Programm
begin
  Close;
end;

procedure TfrmWege.AusgabefeldSelectCell(Sender: TObject; Col,
  Row: Integer; var CanSelect: Boolean);
// Ermittelt den "Torstein" und schaltet zu Prozedur Ausgang
begin
  if IsStein (Row, Col, tor) then Ausgang   // Tor erreicht
end;

procedure TfrmWege.btnPauseClick(Sender: TObject);
// Umschalten der Pausenzeit
begin
  if btnPause.Caption = 'L' then
  begin
    Pausenzeit := 100;
    btnPause.Caption := 'K';
  end
  else
  begin
    Pausenzeit := 1000;
    btnPause.Caption := 'L';  
  end;
end;

procedure TfrmWege.panTorClick(Sender: TObject);
// Schaltet den Programmverlauf weiter
begin
  Abbruch := true;
  panTor.Visible := false;
  panMeldung.Caption := #0;
end;

procedure TfrmWege.panTorMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  // Panel als Schalter * Realisiert die Schalterfunktion (1)
begin
  panTor.BevelOuter := bvLowered;
  panTor.Color := clRed;
end;

procedure TfrmWege.panTorMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  // Panel als Schalter * Realisiert die Schalterfunktion (2)
begin
  panTor.BevelOuter := bvRaised;
  panTor.Color := clRed;
end;

END {der Unit uWege}.
